;##################################################################
;
;   TesBwan for TI-86 (Title screen)
;
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   This program is in the public domain.  There is no warranty.
;
;   This file was last updated August 24, 2002.
;
;##################################################################

title_screen:
        call    _clrLCD

        ld      hl,$100
        ld      (_curRow),hl
        ld      hl,msg1
        call    _puts

        ld      hl,$107
        ld      (_curRow),hl
        ld      hl,msg2
        call    _puts

        xor     a
        ld      (title_pos),a
        ld      hl,message_list
        ld      bc,$70c
title_mloop:
        push    bc
        push    hl
        call    _ldHLind
        ld      b,c
        ld      c,(hl)
        ld      (_penCol),bc
        inc     hl
        call    _vputs
        pop     hl
        inc     hl
        inc     hl
        pop     bc
        ld      a,6
        add     a,c
        ld      c,a
        djnz    title_mloop

title_loop:
        call    CONTRAST_GET_KEY
        cp      K_DOWN
        jr      z,scroll_down
        cp      K_UP
        jr      z,scroll_up
        cp      K_ALPHA
        jr      z,vhs
        cp      K_F1
        jr      z,f1
        cp      K_F2
        jr      z,f2
        cp      K_F3
        jr      z,f3
        cp      K_EXIT
        jr      nz,title_loop
        jp      exit_program

f1:     ld      a,4
        ld      hl,0
fc:     ld      (game_speed),a
        ld      (score),hl
        ret

f2:     ld      a,5
        ld      hl,1
        jr      fc

f3:     ld      a,6
        ld      hl,2
        jr      fc

vhs:    ld      a,2
        ld      (exit_status),a
        pop     af
        ret

scroll_down:
        ld      a,(title_pos)
        cp      num_messages-6
        jr      z,title_loop

        ld      de,$fcc0
        ld      hl,$fd20
        ld      bc,$240
        ldir
        ld      hl,title_pos
        inc     (hl)
        ld      a,(hl)
        add     a,5
        add     a,a
        ld      hl,message_list
        call    ADD_HL_A
        call    _ldHLind
        ld      c,(hl)
        inc     hl
        ld      b,$2a
        ld      (_penCol),bc
        call    _vputs
        jr      title_loop

scroll_up:
        ld      a,(title_pos)
        or      a
        jr      z,title_loop
        ld      de,$ff0f
        ld      hl,$feaf
        ld      bc,$240
        lddr
        ld      hl,title_pos
        dec     (hl)
        ld      a,(hl)
        add     a,a
        ld      hl,message_list
        call    ADD_HL_A
        call    _ldHLind
        ld      c,(hl)
        inc     hl
        ld      b,$0c
        ld      (_penCol),bc
        call    _vputs
        jp      title_loop
                     
msg1:   .db     "TesBwan Version 0.3",0   
msg2:   .db     "Scroll With Up/Down",0

message_list:
        .dw     ms1
        .dw     ms2
        .dw     mb
        .dw     ma1
        .dw     ma2
        .dw     ma3
        .dw     mb
        .dw     mi1
        .dw     mi2
        .dw     mi3
        .dw     mi4
        .dw     mb
        .dw     ml1
        .dw     ml2
        .dw     ml3
        .dw     ml4
                                 
num_messages    =16

ms1:    .db     24,"To begin the game, press",0
ms2:    .db     13,"F1 - slow, F2 - medium, "
        .db     "F3 - fast",0
mb:     .db     0,0
ma1:    .db     10,"Programmed by Patrick"
        .db     " Davidson",0
ma2:    .db     11,"E-Mail - pad@ocf.berkeley."
        .db     "edu",0
ma3:    .db     0,"http://www.ocf."
        .db     "berkeley.edu/~pad/",0
ml1:    .db     1,"This program is in the public "
        .db     "domain so",0
ml2:    .db     1,"it can be copied or modified "
        .db     "with no",0
ml3:    .db     1,"restrictions.  There is no "
        .db     "warranty.",0
ml4:    .db     1,"The source code is on the "
        .db     "web site.",0
mi1:    .db     1,"Use left/right arrows to "
        .db     "move paddle",0
mi3:    .db     1,"Press EXIT to quit the "
        .db     "game (NO!!!)",0
mi2:    .db     1,"Press MORE to save the "
        .db     "game and exit",0
mi4:    .db     1,"Press ENTER to pause, "
        .db     "2nd to unpause",0
